/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	---------------------------------------------------------------------------
	generic WINAMP interface
	---------------------------------------------------------------------------
	$Id: in_xxx.h,v 0.7 2000/03/12 00:32:53 Mamiya Exp $
*/

#define MAX_SAMPLERATE 48000

static In_Module mod;
static volatile struct {
	HANDLE hEvent;
	HANDLE hMutex;
	int request;
	int paused;
	int need_seek;
	int length;
	int isstoped;
	char fn[MAX_PATH];
} player_data = {
	NULL,NULL,
	0,0,0,0,
	1,
	""
};

enum PLAYER_REQUEST {
	PLAYER_REQUEST_QUIT,
	PLAYER_REQUEST_STOP,
	PLAYER_REQUEST_SEEK
};

static void PlayerSetEvent(enum PLAYER_REQUEST request)
{
	if (player_data.hEvent != NULL)
	{
		player_data.request |= 1 << request;
		SetEvent(player_data.hEvent);
	}
}

static unsigned long PlayThread(void *fn)
{
	SEQUENCER *sequencer = NULL;
	int maxlatency = -1, request = 0;
#if !defined(MAX_SAMPLERATE)
	/* Winamp̃oO(dl?)΍ɂ蓮Iobt@͎gps */
	/* (o͂N[Yobt@ɃANZX邽) */
	void *samp_buf = NULL;	/* DYNAMIC ALLOCATION */
#else
	static short samp_buf[((MAX_SAMPLERATE * 30) / 1000) * 2 * 2 + 8];
#endif
	if (1 != InterlockedExchange((LPLONG)&player_data.isstoped, 0)) return -1;
	/* try */
	do
	{
		static int tbl_prio[] = {
			THREAD_PRIORITY_IDLE,
			THREAD_PRIORITY_LOWEST,
			THREAD_PRIORITY_BELOW_NORMAL,
			THREAD_PRIORITY_NORMAL,
			THREAD_PRIORITY_ABOVE_NORMAL,
			THREAD_PRIORITY_HIGHEST,
			THREAD_PRIORITY_TIME_CRITICAL
		};
		int samplerate, bufsize, len, loop_n, loop_c = 0;

		player_data.paused = 0;
		player_data.request = 0;
		ResetEvent(player_data.hEvent);
		/* Đ͏ɔVOi */
		ResetEvent(player_data.hMutex);

		sequencer = loadFile(fn);
		if (sequencer == NULL) break;

		samplerate = sequencer->GetRate(sequencer);

		bufsize = (samplerate * 30) / 1000;	/* 30ms */
#if !defined(MAX_SAMPLERATE)
		samp_buf = malloc(bufsize * 4 * 2 + 8);
		if (samp_buf == NULL) break;
#endif

		maxlatency = mod.outMod->Open(samplerate, 2, 16, 0, 0);
		if (maxlatency < 0) break;

		mod.SetInfo(loop_c, samplerate / 1000, 2, 0);
		mod.SAVSAInit(samplerate, maxlatency);
		mod.VSASetInfo(2, samplerate);
		/* mod.outMod->SetVolume(-666); */

		SetThreadPriority(GetCurrentThread(), tbl_prio[sequencer->GetPriority(sequencer)]);
		sequencer->Play(sequencer);

		while (1)
		{
			int time_pos = sequencer->GetPosition(sequencer);

			loop_n = sequencer->GetLoopCount(sequencer);
			if (loop_c != loop_n)
			{
				loop_c = loop_n;
				mod.SetInfo(loop_c, samplerate / 1000, 2, 0);
			}

			sequencer->Mix(sequencer, samp_buf, bufsize);
			mod.SAAddPCMData(samp_buf, 2, 16, time_pos);
			mod.VSAAddPCMData(samp_buf, 2, 16, time_pos);
			if(mod.dsp_isactive())
			{
				len = mod.dsp_dosamples(samp_buf, bufsize, 16, 2, samplerate);
			}
			else
			{
				len = bufsize;
			}
			while (mod.outMod->CanWrite() < (len << 2))
			{
				DWORD wt;
				wt = WaitForSingleObject(player_data.hEvent, 10);
				if (wt != WAIT_TIMEOUT)
				{
					request = InterlockedExchange((LPLONG)&player_data.request, 0);
					if (request == 0)
					{
						/* ??? THREAD FAULT ??? */
						/* Cȃ^C~OŃ{^ */
						request |= (1 << PLAYER_REQUEST_STOP);
					}
					break;
				}
			}
			if (request & (1 << PLAYER_REQUEST_QUIT)) break;
			if (request & (1 << PLAYER_REQUEST_STOP)) break;
			if (request & (1 << PLAYER_REQUEST_SEEK))
			{
				mod.outMod->Flush(player_data.need_seek);
				sequencer->SetPosition(sequencer, player_data.need_seek);
				player_data.need_seek = 0;
				request = 0;
				continue;
			}
			mod.outMod->Write((char *)samp_buf, (len << 2));
			if (!sequencer->IsPlaying(sequencer))
			{
				/*  ĐI(o͏I҂) */
				while (mod.outMod->IsPlaying())
				{
					DWORD wt;
					wt = WaitForSingleObject(player_data.hEvent, 10);
					if (wt != WAIT_TIMEOUT)
					{
						request = InterlockedExchange((LPLONG)&player_data.request, 0);
						if (request & (1 << PLAYER_REQUEST_QUIT)) break;
						if (request & (1 << PLAYER_REQUEST_STOP)) break;
						/* ??? THREAD FAULT ??? */
						/* Cȃ^C~OŃ{^ */
						request |= (1 << PLAYER_REQUEST_STOP);
						break;
					}
				}
				break;
			}
		}
		sequencer->Stop(sequencer);

	} while(0);
	/* finaly */

	if(sequencer != NULL)
	{
		sequencer->Term(sequencer);
	}

	if (request & (1 << PLAYER_REQUEST_QUIT))
	{
		/* Winamp̃oO(dl?)΍ɂ苭I̓N[YȂ */
		/* (o͂N[YOɏo̓vOIĂ܂) */
	}
	else if (maxlatency >= 0 && mod.outMod)
	{
		mod.outMod->Close();
		mod.SAVSADeInit();
	}

#if !defined(MAX_SAMPLERATE)
	if (samp_buf != NULL) free(samp_buf);
#endif

	/* ҋ@XbhɏIʒm */
	SetEvent(player_data.hMutex);
	InterlockedExchange((LPLONG)&player_data.isstoped, 1);

	if (request & (1 << PLAYER_REQUEST_QUIT))
	{
		/* ANZXᔽ΍ */
		/* (܂Ŗʓ|Ƃ̂H) */
	}
	else if (!(request & (1 << PLAYER_REQUEST_STOP)))
	{
		/* ʏ̏I(IvȊO) */
		/* WINAMPɏIʒm */
#define WM_WA_MPEG_EOF (WM_USER + 2)
		PostMessage(mod.hMainWindow, WM_WA_MPEG_EOF, 0, 0);
	}
	return 0;
}

static void config(HWND hwndParent) {
	ConfigSequencer(hwndParent);
	return;
}

static void about(HWND hwndParent) {
	AboutSequencer(hwndParent);
	return;
}

static void init(void) {
	player_data.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	player_data.hMutex = CreateEvent(NULL, TRUE, TRUE, NULL);
	InitSequencer(mod.hDllInstance);
}

static void quit(void) {
	do
	{
		PlayerSetEvent(PLAYER_REQUEST_QUIT);
		if (player_data.hMutex != NULL)
			WaitForSingleObject(player_data.hMutex, INFINITE);
	} while (!player_data.isstoped);

	QuitSequencer(mod.hDllInstance);
	if (player_data.hEvent != NULL) {
		CloseHandle(player_data.hEvent);
		player_data.hEvent = NULL;
	}
	if (player_data.hMutex != NULL) {
		CloseHandle(player_data.hMutex);
		player_data.hMutex = NULL;
	}
}

static void getfileinfo(char *fn_, char *title, int *length_in_ms) {
	static LONG lock = 1;
	while (1 != InterlockedExchange(&lock, 0)) Sleep(10);
	if (fn_ == NULL || *fn_ == '\0') fn_ = (char *)player_data.fn;
	getFileInfo(fn_, title, length_in_ms);
	InterlockedExchange(&lock, 1);
}

static int infobox(char *fn, HWND hwndParent) {
	return infoBox(fn, hwndParent);
}

static int isourfile(char *fn) {
	return isOurFile(fn);
}

static int play(char *fn) {
	int length = 0;
	char title[256];

	getfileinfo(fn, title, &length);
	player_data.length = length;

	if (player_data.hEvent == NULL || player_data.hMutex == NULL) return 1;

	do
	{
		PlayerSetEvent(PLAYER_REQUEST_STOP);
		if (player_data.hMutex != NULL)
			WaitForSingleObject(player_data.hMutex, INFINITE);
	} while (!player_data.isstoped);

	lstrcpy((char *)player_data.fn, fn);

	/* ĐXbh̐ */
	return (-1 == _beginthread(PlayThread, 0, fn));
}

static void pause(void)
{
	player_data.paused = 1;
	mod.outMod->Pause(1);
}

static void unpause(void)
{
	player_data.paused = 0;
	mod.outMod->Pause(0);
}

static int ispaused(void)
{
	return player_data.paused;
}

static void stop(void)
{
#if 0
	PlayerSetEvent(PLAYER_REQUEST_STOP);
#else
	do
	{
		PlayerSetEvent(PLAYER_REQUEST_STOP);
		if (player_data.hMutex != NULL)
			WaitForSingleObject(player_data.hMutex, INFINITE);
	} while (!player_data.isstoped);
#endif
}

static int getlength(void)
{
	return player_data.length;
}

static int getoutputtime(void)
{
	return mod.outMod->GetOutputTime();
}

static void setoutputtime(int time_in_ms)
{
	player_data.need_seek = time_in_ms;
	PlayerSetEvent(PLAYER_REQUEST_SEEK);
}
static void setvolume(int volume)
{
	mod.outMod->SetVolume(volume);
}

static void setpan(int pan)
{
	mod.outMod->SetPan(pan);
}

static void eq_set(int on, char data[10], int preamp) 
{ 
}

static In_Module mod = {
	IN_VER,
	PLUGIN_NAME,
	0,	/* hMainWindow */
	0,	/* hDllInstance */
	PLUGIN_TYPES,
	1,	/* is_seekable */
	1,	/* UsesOutputPlug */
	config,
	about,
	init,
	quit,
	getfileinfo,
	infobox,
	isourfile,
	play,
	pause,
	unpause,
	ispaused,
	stop,

	getlength,
	getoutputtime,
	setoutputtime,
	setvolume,
	setpan,

	/* pointers filled in by winamp */
	0,0,0,0,0,0,0,0,0,	/* vis stuff */
	0,0,	/* dsp */

	eq_set,	/* EQ, not used */
	NULL,	/* setinfo */
	0		/* out_mod */
};

In_Module __declspec(dllexport) *winampGetInModule2(void)
{
	return &mod;
}

