// ---------------------------------------------------------------------------
//	FM Sound Generator
//	Copyright (C) cisc 1999.
// ---------------------------------------------------------------------------
//	x86/VC engine
// ---------------------------------------------------------------------------
//	$Id: fmgenx86.h,v 1.8 2000/02/09 09:12:38 cisc Exp $

// ---------------------------------------------------------------------------

static void __stdcall FM_NextPhase(Operator* op)
{
	op->ShiftPhase2();
}

extern Operator* popr;
extern Channel4* pch4;

#undef THIS
#define THIS	[ebp]this
#define OP(n)	[ebp]this.op[(n) * TYPE Operator]
#define OPR(r)	[r]popr
#define BUF(n)	[ebp]this.buf[(n) * TYPE int]

// ------------------------------------------------- Envelope Generator

#define EGCALC(r) \
__asm {	add	OPR(r).egstep,3 << (11 + FM_EGBITS) } \
__asm {	cmp	OPR(r).phase,1			} \
__asm {	jz	opc##r##_a				} \
__asm {		mov	eax,OPR(r).eglevel	} \
__asm {		add	eax,OPR(r).egtransd	} \
__asm {		cmp	eax,OPR(r).eglvnext	} \
__asm {		mov	OPR(r).eglevel,eax	} \
__asm {		jb	opc##r##_n			} \
__asm {		jmp	opc##r##_np			} \
opc##r##_a: \
__asm {		mov	eax,OPR(r).eglevel	} \
__asm {		mov	ecx,OPR(r).egtransa	} \
__asm {		mov	ebx,eax				} \
__asm {		dec	eax					} \
__asm {		shr	ebx,cl				} \
__asm {		sub	eax,ebx				} \
__asm {		mov	OPR(r).eglevel,eax	} \
__asm {		jg	opc##r##_n			} \
opc##r##_np: \
__asm {		push r					} \
__asm {		call FM_NextPhase		} \
__asm {	mov	eax,OPR(r).eglevel		} \
opc##r##_n: \
__asm {	add	eax,OPR(r).tlout		} \
__asm {	add	eax,eax					} \
__asm {	cmp	eax,800h				} \
__asm {	jb	opc##r##_n1				} \
__asm {	mov	eax,7feh				} \
opc##r##_n1: \
__asm {	mov	OPR(r).egout,eax		} \
__asm {	ret							}

static void __declspec(naked) FM_EGCS()
{
	EGCALC(esi);
}

static void __declspec(naked) FM_EGCD()
{
	EGCALC(edi);
}

// ------------------------------------------------Operator without LFO

#define OPCALC(n, r)	\
__asm { mov	eax,OPR(r).egstepd } \
__asm { sub	OPR(r).egstep,eax } \
__asm { ja	opc##n } \
__asm { call FM_EGCS } \
opc##n: \
__asm {	mov	eax,OPR(r).pgcount } \
__asm {	mov	ebx,THIS.in[(n-1)*4] } \
__asm {	add	eax,OPR(r).pgdcount } \
__asm {	mov	ebx,[ebx] } \
__asm {	mov	OPR(r).pgcount,eax } \
__asm {	sal	ebx,2+IS2EC_SHIFT } \
__asm {	add	ebx,eax } \
__asm {	shr	ebx,20+FM_PGBITS-FM_OPSINBITS-2 } \
__asm {	and	ebx,(FM_OPSINENTS-1)*4 } \
__asm {	mov	eax,sinetable[ebx] } \
__asm { mov ecx,THIS.out[(n-1)*4] } \
__asm {	add	eax,OPR(r).egout } \
__asm {	mov	ebx,cltable[eax*4] }

ISample __declspec(naked) Channel4::Calc()
{
	__asm
	{
		push ebp
		push ebx
		push esi
		push edi
		
		xor		eax,eax
		mov		ebp,ecx						// = this
		mov		BUF(1),eax
		mov		BUF(2),eax
		mov		BUF(3),eax

		lea		esi,OP(0)

		mov		eax,OPR(esi).egstepd
		sub		OPR(esi).egstep,eax
		ja		opc0
		call	FM_EGCS
	opc0:
		mov		eax,OPR(esi).out
		mov		ebx,OPR(esi).out2
		mov		OPR(esi).out2,eax
		mov		ecx,THIS.fb
		add		ebx,eax
		sal		ebx,1+IS2EC_SHIFT
		mov		eax,OPR(esi).pgcount
		sar		ebx,cl
		add		eax,OPR(esi).pgdcount
		add		ebx,eax
		mov		OPR(esi).pgcount,eax
		shr		ebx,20+FM_PGBITS-FM_OPSINBITS-2
		and		ebx,(FM_OPSINENTS-1)*4
		mov		eax,sinetable[ebx]
		add		eax,OPR(esi).egout
		mov		ebx,cltable[eax*4]
		mov		OPR(esi).out,ebx
		mov		BUF(0),ebx
	}

//op2:
	__asm {	add esi,TYPE Operator }
	OPCALC(1, esi)
	__asm {	add	[ecx],ebx }

	__asm {	add esi,TYPE Operator }
	OPCALC(2, esi)
	__asm {	add	[ecx],ebx }
	
	__asm {	add esi,TYPE Operator }
	OPCALC(3, esi)
	__asm
	{
		pop	edi
		mov eax,[ecx]
		pop	esi
		add	eax,ebx
		pop	ebx
		mov ecx,ebp
		pop	ebp
		ret 0
	}
}

#undef OPCALC

// ---------------------------------------------------Operator with LFO

#define OPCALC(n, r)	\
__asm { mov	eax,OPR(r).egstepd		} \
__asm { sub	OPR(r).egstep,eax		} \
__asm { ja	opc##n					} \
__asm { call FM_EGCS				} \
opc##n: \
__asm { mov	eax,OPR(r).pgdcountl	} \
__asm { mov	ebx,OPR(r).pms			} \
__asm { imul eax,[ebx+edi*4]		} \
__asm { sar	eax,5					} \
__asm { mov	ebx,THIS.in[(n-1)*4]	} \
__asm { add	eax,OPR(r).pgdcount		} \
__asm { mov	ebx,[ebx]				} \
__asm { add	eax,OPR(r).pgcount		} \
__asm { sal	ebx,2+IS2EC_SHIFT		} \
__asm { mov	OP(n).pgcount,eax		} \
__asm { add	ebx,eax					} \
__asm { mov	ecx,THIS.out[(n-1)*4]	} \
__asm { shr	ebx,20+FM_PGBITS-FM_OPSINBITS } \
__asm { and	ebx,FM_OPSINENTS-1		} \
__asm { mov	eax,sinetable[ebx*4]	} \
__asm { add	eax,OPR(r).egout		} \
__asm { mov	ebx,OPR(r).ams			} \
__asm { add	eax,[ebx+edi*4]			} \
__asm { mov	ebx,cltable[eax*4]		}

ISample __declspec(naked) Channel4::CalcL()
{
	__asm
	{
		push ebp
		push ebx
		push esi
		push edi
		
		xor		eax,eax
		mov		ebp,ecx						// = this
		mov		BUF(1),eax
		mov		BUF(2),eax
		mov		BUF(3),eax

		lea		esi,OP(0)
		mov		edi,lfoc

		mov		eax,OPR(esi).egstepd
		sub		OPR(esi).egstep,eax
		ja		opc0
		call	FM_EGCS
	opc0:
		mov		eax,OPR(esi).out
		mov		ebx,OPR(esi).out2
		mov		OPR(esi).out2,eax
		mov		ecx,THIS.fb
		add		ebx,eax
		sal		ebx,1+IS2EC_SHIFT
		
		mov		eax,OPR(esi).pgdcountl
		sar		ebx,cl
		mov		ecx,OPR(esi).pms
		imul	eax,[ecx+edi*4]
		sar		eax,5
		add		eax,OPR(esi).pgcount
		add		eax,OPR(esi).pgdcount
		add		ebx,eax
		mov		OPR(esi).pgcount,eax
		
		shr		ebx,20+FM_PGBITS-FM_OPSINBITS-2
		and		ebx,(FM_OPSINENTS-1)*4
		mov		eax,sinetable[ebx]
		add		eax,OPR(esi).egout
		
		mov		ebx,OPR(esi).ams
		add		eax,[ebx+edi*4]
		
		mov		ebx,cltable[eax*4]
		mov		OPR(esi).out,ebx
		mov		BUF(0),ebx
	}

//op2:
	__asm {	add esi,TYPE Operator }
	OPCALC(1, esi)
	__asm {	add	[ecx],ebx }

	__asm {	add esi,TYPE Operator }
	OPCALC(2, esi)
	__asm {	add	[ecx],ebx }
	
	__asm {	add esi,TYPE Operator }
	OPCALC(3, esi)
	__asm
	{
		pop	edi
		mov eax,[ecx]
		pop	esi
		add	eax,ebx
		pop	ebx
		mov ecx,ebp
		pop	ebp
		ret 0
	
	}
}

#undef OPCALC

// ------------------------------------------Operator without LFO (2ch)

#define OP0(n)	[ebp]pch4.op[(n) * TYPE Operator]
#define OP1(n)	[ebp]pch4.op[(n) * TYPE Operator + CH4S]
#define BUF0(n)	[ebp]pch4.buf[(n) * TYPE int]
#define BUF1(n)	[ebp]pch4.buf[(n) * TYPE int + CH4S]
#define OPR0	[esi]popr
#define OPR1	[edi]popr
#define THIS0	[ebp]pch4
#define THIS1	[ebp + CH4S]pch4

#define OPCALC(n) \
__asm { mov	eax,OPR0.egstepd				} \
__asm { sub	OPR0.egstep,eax					} \
__asm { ja	opc##n##_0						} \
__asm { call FM_EGCS						} \
opc##n##_0: \
__asm { mov	eax,OPR1.egstepd				} \
__asm { sub	OPR1.egstep,eax					} \
__asm { ja	opc##n##_1						} \
__asm { call FM_EGCD						} \
opc##n##_1: \
__asm {	mov	eax,OPR0.pgcount				} \
__asm {	mov	ecx,OPR1.pgcount				} \
__asm {	add	eax,OPR0.pgdcount				} \
__asm {	mov	ebx,THIS0.in[(n-1)*4]			} \
__asm {	mov	edx,THIS1.in[(n-1)*4]			} \
__asm {	add	ecx,OPR1.pgdcount				} \
__asm {	mov	edx,[edx]						} \
__asm {	mov	ebx,[ebx]						} \
__asm {	mov	OPR1.pgcount,ecx				} \
__asm {	sal	edx,2+IS2EC_SHIFT				} \
__asm {	mov	OPR0.pgcount,eax				} \
__asm {	add	edx,ecx							} \
__asm {	sal	ebx,2+IS2EC_SHIFT				} \
__asm {	shr	edx,20+FM_PGBITS-FM_OPSINBITS-2	} \
__asm {	add	ebx,eax							} \
__asm {	and	edx,(FM_OPSINENTS-1)*4			} \
__asm {	shr	ebx,20+FM_PGBITS-FM_OPSINBITS-2	} \
__asm {	mov	ecx,sinetable[edx]				} \
__asm {	and	ebx,(FM_OPSINENTS-1)*4			} \
__asm {	add	ecx,OPR1.egout					} \
__asm {	mov	eax,sinetable[ebx]				} \
__asm {	add	eax,OPR0.egout					} \
__asm {	mov	edx,cltable[ecx*4]				} \
__asm {	mov	ebx,cltable[eax*4]				} \
__asm {	mov	ecx,THIS1.out[(n-1)*4]			} \
__asm {	mov	eax,THIS0.out[(n-1)*4]			}


void __declspec(naked) Channel4::Calc2(Channel4* ch, int* d1, int* d2)
{
	__asm
	{
		push	ebp
		mov		ebp,[esp+2*4][0]		// = ch0
		push	esi
		lea		esi,OP0(0)
		push	edi
		xor		eax,eax
		push	ebx
		push	ecx
		
		mov		BUF0(1),eax
		mov		BUF0(2),eax
		mov		ebx,OPR0.egstepd
		mov		BUF0(3),eax
		lea		edi,OP1(0)
		mov		BUF1(1),eax
		sub		OPR0.egstep,ebx
		mov		BUF1(2),eax
		mov		BUF1(3),eax

		ja		opc0_0
		call	FM_EGCS
	opc0_0:
		mov		ecx,OPR1.egstepd
		sub		OPR1.egstep,ecx
		ja		opc0_1
		call	FM_EGCD
	opc0_1:
		mov		eax,OPR0.out
		mov		ebx,OPR0.out2
		mov		ecx,OPR1.out
		mov		OPR0.out2,eax
		mov		edx,OPR1.out2
		add		ebx,eax
		mov		OPR1.out2,ecx
		add		edx,ecx
		mov		ecx,THIS0.fb	
		sal		ebx,1+IS2EC_SHIFT	
		mov		eax,OPR0.pgcount	
		sar		ebx,cl
		mov		ecx,THIS1.fb
		sal		edx,1+IS2EC_SHIFT
		add		eax,OPR0.pgdcount
		sar		edx,cl
		mov		OPR0.pgcount,eax
		mov		ecx,OPR1.pgcount
		add		ebx,eax
		add		ecx,OPR1.pgdcount
		shr		ebx,20+FM_PGBITS-FM_OPSINBITS-2	
		mov		OPR1.pgcount,ecx	
		and		ebx,(FM_OPSINENTS-1)*4
		add		edx,ecx	
		mov		eax,sinetable[ebx]
		shr		edx,20+FM_PGBITS-FM_OPSINBITS-2
		add		eax,OPR0.egout
		and		edx,(FM_OPSINENTS-1)*4
		mov		ebx,cltable[eax*4]	
		mov		ecx,sinetable[edx]
		mov		OPR0.out,ebx
		add		ecx,OPR1.egout
		mov		edx,cltable[ecx*4]	
		mov		BUF0(0),ebx
		add		esi,TYPE Operator
		mov		OPR1.out,edx
		add		edi,TYPE Operator
		mov		BUF1(0),edx	
	}

//op2:
	OPCALC(1)
	
	__asm { add	[ecx],edx }
	__asm {	add esi,TYPE Operator }
	__asm { add	[eax],ebx }
	__asm {	add edi,TYPE Operator }
	
	OPCALC(2)
	
	__asm { add	[ecx],edx }
	__asm {	add esi,TYPE Operator }
	__asm { add	[eax],ebx }
	__asm {	add edi,TYPE Operator }
	
	OPCALC(3)
	__asm
	{
		add edx,[ecx]
		mov esi,[esp+6*4][4]
		add ebx,[eax]
		mov edi,[esp+6*4][8]
		add [esi],ebx
		add [edi],edx
		pop	ebx
		pop ecx
		pop	edi
		pop	esi
		pop	ebp
		ret 0
	}
}

#undef OPCALC


// ---------------------------------------------Operator with LFO (2ch)

#undef OPR1
#define OPR1	[esi + CH4S]popr

#define OPCALC(n) \
__asm { mov	eax,OPR0.egstepd				} \
__asm { sub	OPR0.egstep,eax					} \
__asm { ja	opc##n##_0						} \
__asm { call FM_EGCS						} \
opc##n##_0: \
__asm { mov	eax,OPR1.egstepd				} \
__asm { sub	OPR1.egstep,eax					} \
__asm { ja	opc##n##_1						} \
__asm { add esi,CH4S						} \
__asm { call FM_EGCS						} \
__asm { sub esi,CH4S						} \
opc##n##_1: \
__asm { mov	eax,OPR0.pgdcountl				} \
__asm { mov	ebx,OPR0.pms					} \
__asm { mov	ecx,OPR1.pgdcountl				} \
__asm { imul eax,[ebx+edi*4]				} \
__asm { mov	edx,OPR1.pms					} \
__asm { sar	eax,5							} \
__asm { imul ecx,[edx+edi*4]				} \
__asm { mov	ebx,THIS0.in[(n-1)*4]			} \
__asm { sar	ecx,5							} \
__asm { add	eax,OPR0.pgdcount				} \
__asm { mov	edx,THIS1.in[(n-1)*4]			} \
__asm { mov	ebx,[ebx]						} \
__asm { add	ecx,OPR1.pgdcount				} \
__asm { mov	edx,[edx]						} \
__asm { add	eax,OPR0.pgcount				} \
__asm { sal	ebx,2+IS2EC_SHIFT				} \
__asm { add	ecx,OPR1.pgcount				} \
__asm { sal	edx,2+IS2EC_SHIFT				} \
__asm { mov	OPR0.pgcount,eax				} \
__asm { add	edx,ecx							} \
__asm { mov	OPR1.pgcount,ecx				} \
__asm { shr	edx,20+FM_PGBITS-FM_OPSINBITS	} \
__asm { add	ebx,eax							} \
__asm { and	edx,FM_OPSINENTS-1				} \
__asm { shr	ebx,20+FM_PGBITS-FM_OPSINBITS	} \
__asm { mov	ecx,sinetable[edx*4]			} \
__asm { and	ebx,FM_OPSINENTS-1				} \
__asm { add	ecx,OPR1.egout					} \
__asm { mov	eax,sinetable[ebx*4]			} \
__asm { mov	edx,OPR1.ams					} \
__asm { add	eax,OPR0.egout					} \
__asm { mov	ebx,OPR0.ams					} \
__asm { add	ecx,[edx+edi*4]					} \
__asm { mov	edx,cltable[ecx*4]				} \
__asm { add	eax,[ebx+edi*4]					} \
__asm { mov	ecx,THIS1.out[(n-1)*4]			} \
__asm { mov	ebx,cltable[eax*4]				} \
__asm { mov	eax,THIS0.out[(n-1)*4]			} 

void __declspec(naked) Channel4::CalcL2(Channel4* ch, int* d1, int* d2)
{
	__asm
	{
		push	ebp
		mov		ebp,[esp+2*4][0]		// = ch0
		push	esi
		xor		eax,eax
		push	edi
		lea		esi,OP0(0)
		push	ebx
		push	ecx
		
		mov		BUF0(1),eax
		mov		ebx,OPR0.egstepd
		mov		BUF0(2),eax
		mov		BUF0(3),eax
		mov		edi,lfoc
		mov		BUF1(1),eax
		sub		OPR0.egstep,ebx
		mov		BUF1(2),eax
		mov		BUF1(3),eax

		ja		opc0_0
		call	FM_EGCS
	opc0_0:
		mov		ecx,OPR1.egstepd
		sub		OPR1.egstep,ecx
		ja		opc0_1
		add		esi,CH4S
		call	FM_EGCS
		sub		esi,CH4S
	opc0_1:
		mov		eax,OPR0.out			
		mov		ebx,OPR0.out2			
		mov		OPR0.out2,eax	
		mov		ecx,OPR1.out			
		mov		edx,OPR1.out2			
		mov		OPR1.out2,ecx			
		add		ebx,eax				
		add		edx,ecx				
		sal		ebx,1+IS2EC_SHIFT		
		mov		ecx,THIS0.fb			
		mov		eax,OPR0.pgdcountl		
		sar		ebx,cl				
		sal		edx,1+IS2EC_SHIFT		
		push	ebx				
		mov		ecx,THIS1.fb			
		mov		ebx,OPR0.pms			
		sar		edx,cl				
		imul	eax,[ebx+edi*4]			
		mov		ecx,OPR1.pgdcountl		
		mov		ebx,OPR1.pms			
		imul	ecx,[ebx+edi*4]			
		sar		eax,5				
		sar		ecx,5				
		add		eax,OPR0.pgcount			
		add		ecx,OPR1.pgcount			
		add		eax,OPR0.pgdcount		
		add		ecx,OPR1.pgdcount		
		pop		ebx				
		mov		OPR1.pgcount,ecx			
		add		ebx,eax				
		mov		OPR0.pgcount,eax			
		shr		ebx,20+FM_PGBITS-FM_OPSINBITS-2	
		add		edx,ecx				
		and		ebx,(FM_OPSINENTS-1)*4		
		shr		edx,20+FM_PGBITS-FM_OPSINBITS-2	
		mov		eax,sinetable[ebx]		
		and		edx,(FM_OPSINENTS-1)*4		
		add		eax,OPR0.egout
		mov		ecx,sinetable[edx]
		add		ecx,OPR1.egout
		mov		ebx,OPR0.ams
		add		eax,[ebx+edi*4]			
		mov		edx,OPR1.ams			
		mov		ebx,cltable[eax*4]		
		add		ecx,[edx+edi*4]			
		mov		OPR0.out,ebx			
		mov		edx,cltable[ecx*4]		
		mov		BUF0(0),ebx			
		mov		OPR1.out,edx			
		mov		BUF1(0),edx			
		add		esi,TYPE Operator
	}

//op2:
	OPCALC(1)
	
	__asm { add	[ecx],edx }
	__asm {	add esi,TYPE Operator }
	__asm { add	[eax],ebx }
	
	OPCALC(2)
	
	__asm { add	[ecx],edx }
	__asm {	add esi,TYPE Operator }
	__asm { add	[eax],ebx }
	
	OPCALC(3)
	__asm
	{
		add edx,[ecx]
		mov esi,[esp+6*4][4]
		add ebx,[eax]
		mov edi,[esp+6*4][8]
		add [esi],ebx
		add [edi],edx
		pop	ebx
		pop ecx
		pop	edi
		pop	esi
		pop	ebp
		ret 0
	}
}

#undef OPCALC

